#   File:       FATSimpleText.make
#   Target:     FATSimpleText
#   Sources:    AboutBox.c
#               Clipboard.c
#               GXFile.c
#               MovieFile.c
#               PICTFile.c
#               SimpleText.c
#               TextDrag.c
#               TextFile.a
#               TextFile.c
#               ThreeDMetafile.c
#   Created:    Thursday, September 26, 1996 05:14:37 PM


MAKEFILE     = 
MondoBuild = {MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified
Includes     = 
		-i "{MPW}Interfaces&Libraries:Interfaces:CIncludes:" 
		-i "{MPW}Interfaces&Libraries:Interfaces:RIncludes:"
SymPPC      = 
ObjDirPPC   =
Sym68K      = 
ObjDir68K   =

PPCCOptions  = {Includes} {SymPPC} 

COptions     = {Includes} {Sym68K} -w 17 -model far

ObjectsPPC  = 
		"{ObjDirPPC}AboutBox.c.x" 
		"{ObjDirPPC}Clipboard.c.x" 
		"{ObjDirPPC}GXFile.c.x" 
		"{ObjDirPPC}MovieFile.c.x" 
		"{ObjDirPPC}PICTFile.c.x" 
		"{ObjDirPPC}SimpleText.c.x" 
		"{ObjDirPPC}TextDrag.c.x" 
		"{ObjDirPPC}TextFile.c.x" 
		"{ObjDirPPC}ThreeDMetafile.c.x" 
		AGFileLib.xcoff 
		AppleGuideGlue.xcoff
		
Objects68K  = 
		"{ObjDir68K}AboutBox.c.o" 
		"{ObjDir68K}Clipboard.c.o" 
		"{ObjDir68K}GXFile.c.o" 
		"{ObjDir68K}MovieFile.c.o" 
		"{ObjDir68K}PICTFile.c.o" 
		"{ObjDir68K}SimpleText.c.o" 
		"{ObjDir68K}TextDrag.c.o" 
		"{ObjDir68K}TextFile.a.o" 
		"{ObjDir68K}TextFile.c.o" 
		"{ObjDir68K}ThreeDMetafile.c.o" 
		AGFileLib.o


FATSimpleText  {MondoBuild} {ObjectsPPC}
	PPCLink 
		-o {Targ} {SymPPC} 
		{ObjectsPPC} 
		-t 'APPL' 
		-c 'ttxt' 
		-weaklib "QuickTimeLib" 
		-weaklib "ThreadsLib" 
		-weaklib "SpeechLib" 
		-weaklib "DragLib" 
		-weaklib "QuickDrawGXLib" 
		"{SharedLibraries}QuickTimeLib" 
		"{SharedLibraries}ThreadsLib" 
		"{SharedLibraries}SpeechLib" 
		"{SharedLibraries}DragLib" 
		"{SharedLibraries}QuickDrawGXLib" 
		"{SharedLibraries}InterfaceLib" 
		"{SharedLibraries}StdCLib" 
		"{SharedLibraries}MathLib" 
		"{PPCLibraries}StdCRuntime.o" 
		"{PPCLibraries}PPCCRuntime.o" 
		"{PPCLibraries}PPCToolLibs.o"


FATSimpleText  {MondoBuild} {Objects68K}
	Link 
		-o {Targ} -d {Sym68K} 
		{Objects68K} 
		-t 'APPL' 
		-c 'ttxt' 
		-model far 
		"{CLibraries}StdCLib.o" 
		"{Libraries}MacRuntime.o" 
		"{Libraries}Interface.o"
		
FATSimpleText  {MondoBuild} SimpleText.r
	Rez SimpleText.r -o {Targ} {Includes} -append

"{ObjDirPPC}AboutBox.c.x"  {MondoBuild} AboutBox.c
	{PPCC} AboutBox.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}Clipboard.c.x"  {MondoBuild} Clipboard.c
	{PPCC} Clipboard.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}GXFile.c.x"  {MondoBuild} GXFile.c
	{PPCC} GXFile.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}MovieFile.c.x"  {MondoBuild} MovieFile.c
	{PPCC} MovieFile.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}PICTFile.c.x"  {MondoBuild} PICTFile.c
	{PPCC} PICTFile.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}SimpleText.c.x"  {MondoBuild} SimpleText.c
	{PPCC} SimpleText.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}TextDrag.c.x"  {MondoBuild} TextDrag.c
	{PPCC} TextDrag.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}TextFile.c.x"  {MondoBuild} TextFile.c
	{PPCC} TextFile.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}ThreeDMetafile.c.x"  {MondoBuild} ThreeDMetafile.c
	{PPCC} ThreeDMetafile.c -o {Targ} {PPCCOptions}


"{ObjDir68K}AboutBox.c.o"  {MondoBuild} AboutBox.c
	{C} AboutBox.c -o {Targ} {COptions}

"{ObjDir68K}Clipboard.c.o"  {MondoBuild} Clipboard.c
	{C} Clipboard.c -o {Targ} {COptions}

"{ObjDir68K}GXFile.c.o"  {MondoBuild} GXFile.c
	{C} GXFile.c -o {Targ} {COptions}

"{ObjDir68K}MovieFile.c.o"  {MondoBuild} MovieFile.c
	{C} MovieFile.c -o {Targ} {COptions}

"{ObjDir68K}PICTFile.c.o"  {MondoBuild} PICTFile.c
	{C} PICTFile.c -o {Targ} {COptions}

"{ObjDir68K}SimpleText.c.o"  {MondoBuild} SimpleText.c
	{C} SimpleText.c -o {Targ} {COptions}

"{ObjDir68K}TextDrag.c.o"  {MondoBuild} TextDrag.c
	{C} TextDrag.c -o {Targ} {COptions}

"{ObjDir68K}TextFile.a.o"  {MondoBuild} TextFile.a
	{Asm} TextFile.a -o {Targ} {AOptions}

"{ObjDir68K}TextFile.c.o"  {MondoBuild} TextFile.c
	{C} TextFile.c -o {Targ} {COptions}

"{ObjDir68K}ThreeDMetafile.c.o"  {MondoBuild} ThreeDMetafile.c
	{C} ThreeDMetafile.c -o {Targ} {COptions}

