/*------------------------------------------------------------------------------
#
#	Macintosh Developer Technical Support
#
#	MoreATSUnicode.h	-	Header
#
#	Copyright  1998 Apple Computer, Inc.
#	All rights reserved.
#	
#	You may incorporate this sample code into your applications without
#	restriction, though the sample code has been provided "AS IS" and the
#	responsibility for its operation is 100% yours.  However, what you are
#	not permitted to do is to redistribute the source as "DSC Sample Code"
#	after having made changes. If you're going to re-distribute the source,
#	we require that you make it clear in the source that the code was
#	descended from Apple Sample Code, but that you've made changes.
#
#	Versions:	1.0					7/98
#
------------------------------------------------------------------------------*/

#include <MacTypes.h>
#include <ATSUnicode.h>
#include <Menus.h>
#include <Quickdraw.h>


/* Getters and Setters */

extern OSStatus atsuSetBooleanAttribute( ATSUStyle, Boolean, ATSUAttributeTag );
extern OSStatus atsuSetFixedAttribute( ATSUStyle, Fixed, ATSUAttributeTag );
extern OSStatus atsuSetFractAttribute( ATSUStyle, Fract, ATSUAttributeTag );

extern OSStatus atsuGetOneAttribute( ATSUStyle 				iStyle,
									 ATSUAttributeTag 		iTag,
									 ByteCount 				iExpectedValueSize,
									 ATSUAttributeValuePtr 	oValue );

#define atsuSetQDBold( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUQDBoldfaceTag )
#define atsuGetQDBold( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUQDBoldfaceTag, sizeof(Boolean), oSettingPtr )

#define atsuSetQDItalic( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUQDItalicTag )
#define atsuGetQDItalic( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUQDItalicTag, sizeof(Boolean), oSettingPtr )

#define atsuSetQDUnderline( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUQDUnderlineTag )
#define atsuGetQDUnderline( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUQDUnderlineTag, sizeof(Boolean), oSettingPtr )

#define atsuSetQDCondensed( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUQDCondensedTag )
#define atsuGetQDCondensed( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUQDCondensedTag, sizeof(Boolean), oSettingPtr )

#define atsuSetQDExtended( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUQDExtendedTag )
#define atsuGetQDExtended( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUQDExtendedTag, sizeof(Boolean), oSettingPtr )

extern OSStatus atsuSetFont( ATSUStyle, ATSUFontID );
#define atsuGetFont( iStyle, oFontIDPtr )	atsuGetOneAttribute( iStyle, kATSUFontTag, sizeof(ATSUFontID), oFontIDPtr );

#define atsuSetSize( iStyle, iSize )		atsuSetFixedAttribute( iStyle, iSize, kATSUSizeTag )
#define atsuGetSize( iStyle, oSizePtr )		atsuGetOneAttribute( iStyle, kATSUSizeTag, sizeof(Fixed), oSizePtr );

extern OSStatus atsuSetColor( ATSUStyle, RGBColor );
#define atsuGetColor( iStyle, oColorPtr )	atsuGetOneAttribute( iStyle, kATSUColorTag, sizeof(RGBColor), oColorPtr );

extern OSStatus atsuSetLanguage( ATSUStyle, RegionCode );
#define atsuGetLanguage( iStyle, oLanguagePtr )	atsuGetOneAttribute( iStyle, kATSULanguageTag, sizeof(RegionCode), oLanguagePtr );

extern OSStatus atsuSetVerticalCharacter( ATSUStyle, ATSUVerticalCharacterType );
#define atsuGetVerticalCharacter( iStyle, oVerticalCharPtr )	atsuGetOneAttribute( iStyle, kATSUVerticalCharacterTag, sizeof(ATSUVerticalCharacterType), oVerticalCharPtr );

#define atsuSetImposedWidth( iStyle, iWidth )		atsuSetFixedAttribute( iStyle, iWidth, kATSUImposeWidthTag )
#define atsuGetImposedWidth( iStyle, oWidthPtr )	atsuGetOneAttribute( iStyle, kATSUImposeWidthTag, sizeof(ATSUTextMeasurement), oWidthPtr );

#define atsuSetBeforeWidthStreamShift( iStyle, iValue )		atsuSetFixedAttribute( iStyle, iValue, kATSUBeforeWithStreamShiftTag )
#define atsuGetBeforeWidthStreamShift( iStyle, iValuePtr )	atsuGetOneAttribute( iStyle, kATSUBeforeWithStreamShiftTag, sizeof(Fixed), iValuePtr );

#define atsuSetAfterWidthStreamShift( iStyle, iValue )		atsuSetFixedAttribute( iStyle, iValue, kATSUAfterWithStreamShiftTag )
#define atsuGetAfterWidthStreamShift( iStyle, iValuePtr )	atsuGetOneAttribute( iStyle, kATSUAfterWithStreamShiftTag, sizeof(Fixed), iValuePtr );

#define atsuSetCrossStreamShift( iStyle, iValue )		atsuSetFixedAttribute( iStyle, iValue, kATSUCrossStreamShiftTag )
#define atsuGetCrossStreamShift( iStyle, iValuePtr )	atsuGetOneAttribute( iStyle, kATSUCrossStreamShiftTag, sizeof(Fixed), iValuePtr );

#define atsuSetTracking( iStyle, iValue )		atsuSetFixedAttribute( iStyle, iValue, kATSUTrackingTag )
#define atsuGetTracking( iStyle, iValuePtr )	atsuGetOneAttribute( iStyle, kATSUTrackingTag, sizeof(Fixed), iValuePtr );

#define atsuSetHangingInhibitFactor( iStyle, iValue )		atsuSetFractAttribute( iStyle, iValue, kATSUHangingInhibitFactorTag )
#define atsuGetHangingInhibitFactor( iStyle, iValuePtr )	atsuGetOneAttribute( iStyle, kATSUHangingInhibitFactorTag, sizeof(Fract), iValuePtr );

#define atsuSetKerningInhibitFactor( iStyle, iValue )		atsuSetFractAttribute( iStyle, iValue, kATSUKerningInhibitFactorTag )
#define atsuGetKerningInhibitFactor( iStyle, iValuePtr )	atsuGetOneAttribute( iStyle, kATSUKerningInhibitFactorTag, sizeof(Fract), iValuePtr );

#define atsuSetDecompositionFactor( iStyle, iValue )		atsuSetFixedAttribute( iStyle, iValue, kATSUDecompositionFactorTag )
#define atsuGetDecompositionFactor( iStyle, iValuePtr )		atsuGetOneAttribute( iStyle, kATSUDecompositionFactorTag, sizeof(Fixed), iValuePtr );

extern OSStatus atsuSetBaselineClass( ATSUStyle, BslnBaselineClass );
#define atsuGetBaselineClass( iStyle, oBaselineClassPtr )	atsuGetOneAttribute( iStyle, kATSUBaselineClassTag, sizeof(BslnBaselineClass), oBaselineClassPtr );

extern OSStatus atsuSetPriorityJustOverride( ATSUStyle, ATSJustPriorityWidthDeltaOverrides );
#define atsuGetPriorityJustOverride( iStyle, oBaselineClassPtr )	atsuGetOneAttribute( iStyle, kATSUPriorityJustOverrideTag, sizeof(ATSJustPriorityWidthDeltaOverrides), oBaselineClassPtr );
																
#define atsuSetNoLigatureSplit( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUNoLigatureSplitTag )
#define atsuGetNoLigatureSplit( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUNoLigatureSplitTag, sizeof(Boolean), oSettingPtr )

#define atsuSetNoCaretAngle( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUNoCaretAngleTag )
#define atsuGetNoCaretAngle( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUNoCaretAngleTag, sizeof(Boolean), oSettingPtr )

#define atsuSetSuppressCrossKerning( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUSuppressCrossKerningTag )
#define atsuGetSuppressCrossKerning( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUSuppressCrossKerningTag, sizeof(Boolean), oSettingPtr )

#define atsuSetNoOpticalAlignment( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUNoOpticalAlignmentTag )
#define atsuGetNoOpticalAlignment( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUNoOpticalAlignmentTag, sizeof(Boolean), oSettingPtr )

#define atsuSetForceHanging( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUForceHangingTag )
#define atsuGetForceHanging( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUForceHangingTag, sizeof(Boolean), oSettingPtr )

#define atsuSetNoSpecialJustification( iStyle, iSetting )		atsuSetBooleanAttribute( iStyle, iSetting, kATSUNoSpecialJustificationTag )
#define atsuGetNoSpecialJustification( iStyle, oSettingPtr )	atsuGetOneAttribute( iStyle, kATSUNoSpecialJustificationTag, sizeof(Boolean), oSettingPtr )


extern OSStatus atsuSetBooleanLayoutControl( ATSUTextLayout, Boolean, ATSUAttributeTag );
extern OSStatus atsuSetFixedLayoutControl( ATSUTextLayout, Fixed, ATSUAttributeTag );
extern OSStatus atsuSetFractLayoutControl( ATSUTextLayout, Fract, ATSUAttributeTag );

extern OSStatus atsuGetOneLayoutControl( ATSUTextLayout 		iLayout,
										 ATSUAttributeTag 		iTag,
										 ByteCount 				iExpectedValueSize,
										 ATSUAttributeValuePtr 	oValue );

#define atsuSetLineWidth( iLayout, iWidth )		atsuSetFixedLayoutControl( iLayout, iWidth, kATSULineWidthTag )
#define atsuGetLineWidth( iLayout, oWidthPtr)	atsuGetOneLayoutControl( iLayout, kATSULineWidthTag, sizeof(ATSUTextMeasurement), oWidthPtr )

#define atsuSetLineRotation( iLayout, iAngle )		atsuSetFixedLayoutControl( iLayout, iAngle, kATSULineRotationTag )
#define atsuGetLineRotation( iLayout, oAnglePtr)	atsuGetOneLayoutControl( iLayout, kATSULineRotationTag, sizeof(Fixed), oAnglePtr )

#define atsuSetLineDirection( iLayout, iDirection )			atsuSetBooleanLayoutControl( iLayout, iDirection, kATSULineDirectionTag )
#define atsuGetLineDirection( iLayout, oDirectionPtr )		atsuGetOneLayoutControl( iLayout, kATSULineDirectionTag, sizeof(Boolean), oDirectionPtr )

#define atsuSetLineJustFactor( iLayout, iValue )		atsuSetFractLayoutControl( iLayout, iValue, kATSULineJustificationFactorTag )
#define atsuGetLineJustFactor( iLayout, oValuePtr )		atsuGetOneLayoutControl( iLayout, kATSULineJustificationFactorTag, sizeof(Fract), oValuePtr )

#define atsuSetLineFlushFactor( iLayout, iValue )		atsuSetFractLayoutControl( iLayout, iValue, kATSULineFlushFactorTag )
#define atsuGetLineFlushFactor( iLayout, oValuePtr )	atsuGetOneLayoutControl( iLayout, kATSULineFlushFactorTag, sizeof(Fract), oValuePtr )

extern OSStatus atsuSetLineBaselineValues( ATSUTextLayout, BslnBaselineRecord );
#define atsuGetLineBaselineValues( iLayout, oValuePtr )	atsuGetOneLayoutControl( iLayout, kATSULineBaselineValuesTag, sizeof(BslnBaselineRecord), oValuePtr )

extern OSStatus atsuSetLineLayoutOptions( ATSUTextLayout, UInt32 );
#define atsuGetLineLayoutOptions( iLayout, oOptionsPtr )	atsuGetOneLayoutControl( iLayout, kATSULineLayoutOptionsTag, sizeof(UInt32), oOptionsPtr )


/* Some convenient macros for counting things */
#define atsuCountSoftLineBreaks( iTextLayout, iRangeStart, iRangeLength, oBreakCount ) \
	ATSUGetSoftLineBreaks( iTextLayout, iRangeStart, iRangeLength, 0, NULL, oBreakCount )
	

extern OSStatus atsuSetStyleFromGrafPtr( ATSUStyle iStyle, GrafPtr grafPtr, Boolean clearExistingAttributes );


extern OSStatus atsuCloneTextLayout(
			ATSUTextLayout iTextLayout, UniCharArrayOffset iOffset, UniCharCount iLength, Boolean expandToLineBoundary,
			ATSUTextLayout *oTextLayout );


/* Measurement */

typedef struct atsuFixedPt {
	Fixed x;
	Fixed y;
} atsuFixedPt;


extern OSStatus	atsuMeasureRotatedTextImage( ATSUTextLayout iTextLayout, 
			UniCharArrayOffset iLineOffset,
			UniCharCount iLineLength,
			ATSUTextMeasurement iLocationX,
			ATSUTextMeasurement iLocationY,
			atsuFixedPt *p1,
			atsuFixedPt *p2,
			atsuFixedPt *p3,
			atsuFixedPt *p4
			);


/* Simple Drawing */

extern OSStatus atsuDrawText( ConstUniCharArrayPtr	iTextBuf,
							  UniCharArrayOffset	iFirstChar,
							  UniCharCount			iCharCount );

/* Standard Font Menu */

extern OSStatus atsuAppendFontMenu( MenuHandle theMenu, short firstHierMenuID, short *oSubmenuCount, void **menuLookupCookie );

extern ATSUFontID atsuGetFontForFontMenuItem( short menuID, short itemNum, void *menuLookupCookie );

extern OSStatus atsuDisposeFontMenuLookupCookie( void *menuLookupCookie );
