/*------------------------------------------------------------------------------
#
#	Macintosh Developer Technical Support
#
#	MoreATSUnicodeTextBox.h	-	Header
#
#	Copyright  1998 Apple Computer, Inc.
#	All rights reserved.
#	
#	You may incorporate this sample code into your applications without
#	restriction, though the sample code has been provided "AS IS" and the
#	responsibility for its operation is 100% yours.  However, what you are
#	not permitted to do is to redistribute the source as "DSC Sample Code"
#	after having made changes. If you're going to re-distribute the source,
#	we require that you make it clear in the source that the code was
#	descended from Apple Sample Code, but that you've made changes.
#
#	Versions:	1.0					7/98
#
------------------------------------------------------------------------------*/

#ifndef __ATSUNICODE__
#include <ATSUnicode.h>
#endif


/*
	ATSUI version of TETextBox. Adds support for justification and 
	simple vertical text (i.e. one orientation for CJK and non-CJK characters)
	
	Text font and size are taken from the current port settings
	
	flushness is as defined in <TextEdit.h>: teFlushLeft, teCenter, teFlushRight
	
	justification is a Fract between 0 and 1 as in ATSUnicode.h
	
	text orientation is the enum defined below
	
*/

enum {
	kHorizontalText = 0,
	kVerticalText =1
	};

OSStatus atsuTextBox(	ConstUniCharArrayPtr 	iText,
						UniCharCount 			iTextLength,
						const Rect *			iBox,
						short 					flushness,
						Fract					justification,
						short					textOrientation,
						Boolean					useFontFallBacks);
						

/*
	Draws a Text layout within the specified rect.
	Assumes that the layout has already been initialized
	and all required attributes and line controls have been set
	by the client.
	
	Called by atsuTextBox
*/
OSStatus atsuDrawTextInBox(	ATSUTextLayout 			iTextLayout,
							const Rect *			iBox);
