/*------------------------------------------------------------------------------
#
#	Macintosh Developer Technical Support
#
#	Simple Apple Text Services For Unicode Imaging (ATSUI) Sample Application
#
#	TypeServicesForUnicode
#
#	SampleWindow_5.h	-	Header
#
#	Copyright  1998 Apple Computer, Inc.
#	All rights reserved.
#	
#	You may incorporate this sample code into your applications without
#	restriction, though the sample code has been provided "AS IS" and the
#	responsibility for its operation is 100% yours.  However, what you are
#	not permitted to do is to redistribute the source as "DSC Sample Code"
#	after having made changes. If you're going to re-distribute the source,
#	we require that you make it clear in the source that the code was
#	descended from Apple Sample Code, but that you've made changes.
#
#	Versions:	1.0					7/98
#
#	Implements the Window from menu item 5 of 'Demos' menu:
#	
#		Hilighting and Caret/Cursor movements
#
------------------------------------------------------------------------------*/

#ifndef __SAMPLEWINDOW_5__
#define __SAMPLEWINDOW_5__

typedef struct
	{
	UniCharArrayOffset selStart;		// start of the selected block in the line
	UniCharCount selLength;				// length of the selected block
	ATSUTextMeasurement xLineSel;		// graphical position of the line start at x
	ATSUTextMeasurement yLineSel;		//                                     and y
	} SelectedBlock;

typedef struct
	{
	Boolean withHilight;				// do we currently have hilighted text
	UniCharArrayOffset caret;			// logical position of the caret
	UniCharCount length;				// length of the selection
	ItemCount numberOfSelectedLines;	// number of lines on which the selection extends
	SelectedBlock *selBlocks;			// array of selected blocks
	} Sample5_PrivateData;

OSErr NewHighlightingCaretsCursorMovementsWindow();
void SetSelectedBlocks(WindowDataPtr wdataP);
void HilightAndOrMove(WindowDataPtr wdataP, long what);
void ActivateSample5Window(WindowPtr theWind, WindowDataPtr wdataP, Boolean active);
void UpdateSample5Window(WindowPtr theWind, WindowDataPtr wdataP);
void DisposeSample5Window(WindowDataPtr wdataP);
void HilightCurrentSelection(WindowDataPtr wdataP);
void UnhilightCurrentSelection(WindowDataPtr wdataP);
void BetterSmallerBiggerFont(WindowDataPtr wdataP, Fixed variation);

#endif
