/*------------------------------------------------------------------------------
#
#	Macintosh Developer Technical Support
#
#	Simple Apple Text Services For Unicode Imaging (ATSUI) Sample Application
#
#	TypeServicesForUnicode
#
#	SampleWindow_6.h	-	Header
#
#	Copyright  1998 Apple Computer, Inc.
#	All rights reserved.
#	
#	You may incorporate this sample code into your applications without
#	restriction, though the sample code has been provided "AS IS" and the
#	responsibility for its operation is 100% yours.  However, what you are
#	not permitted to do is to redistribute the source as "DSC Sample Code"
#	after having made changes. If you're going to re-distribute the source,
#	we require that you make it clear in the source that the code was
#	descended from Apple Sample Code, but that you've made changes.
#
#	Versions:	1.0					7/98
#
#	Implements the Window from menu item 6 of 'Demos' menu:
#	
#		Hit Testing
#
------------------------------------------------------------------------------*/

#ifndef __SAMPLEWINDOW_6__
#define __SAMPLEWINDOW_6__

typedef struct
	{
	Boolean withHilight;				//
	UniCharArrayOffset caret;			//
	UniCharCount length;				// these 5 first fields are exactly the same
	ItemCount numberOfSelectedLines;	// as those defined in Sample5_PrivateData
	SelectedBlock *selBlocks;			//
	
	long lastClickTime;					// time and Point of last click to check
	Point lastClickPoint;				// for double-click
	} Sample6_PrivateData;

OSErr NewHitTestingWindow();
UniCharArrayOffset WhereInTextIsThisPoint(WindowDataPtr wdataP, Point thePoint, Boolean *leading);
void ClickInSample6Window(WindowDataPtr wdataP, EventRecord *theEvent);
Boolean GotDoubleClick(WindowDataPtr wdataP, EventRecord *theEvent);
void SelectWord(WindowDataPtr wdataP, UniCharArrayOffset thePos, Boolean leading, UniCharArrayOffset *startSel, UniCharArrayOffset *endSel);

#endif
