/*------------------------------------------------------------------------------
#
#	Macintosh Developer Technical Support
#
#	Simple Apple Text Services For Unicode Imaging (ATSUI) Sample Application
#
#	TypeServicesForUnicode
#
#	SampleWindow_8.cp	-	C++ Source
#
#	Copyright  1998 Apple Computer, Inc.
#	All rights reserved.
#	
#	You may incorporate this sample code into your applications without
#	restriction, though the sample code has been provided "AS IS" and the
#	responsibility for its operation is 100% yours.  However, what you are
#	not permitted to do is to redistribute the source as "DSC Sample Code"
#	after having made changes. If you're going to re-distribute the source,
#	we require that you make it clear in the source that the code was
#	descended from Apple Sample Code, but that you've made changes.
#
#	Versions:	1.0					7/98
#
#	Implements the Window from menu item 8 of 'Demos' menu:
#	
#		ATSUI Text Box
#
------------------------------------------------------------------------------*/

#include <ATSUnicode.h>
#include <FixMath.h>

#include "MoreATSUnicodeTextBox.h"

#include "SomeUnicodeStuff.h"
#include "WindowUtilities.h"
#include "SampleWindow_8.h"

#include "TypeServicesForUnicode.h"

#define kJustShortMax 10000

UniCharArrayPtr gDlgUnicodeText;			// the Text in Unicode
UniCharCount gDlgTextLength;				// its length

OSStatus UpdateUserItem(DialogPtr theDialog)
	{
	OSStatus status = noErr;

	short itemType;
	Handle item;
	Rect box;
	
	// get the values selected by the user for the flushness...
	short flushness;
	GetDialogItem(theDialog, 1, &itemType, &item, &box);
	if (GetControlValue((ControlHandle)item) == 1) flushness = teFlushLeft;
	else
		{
		GetDialogItem(theDialog, 2, &itemType, &item, &box);
		if (GetControlValue((ControlHandle)item) == 1) flushness = teCenter;
		else flushness = teFlushRight;
		}
	
	// ...justification...
	Fract justification;
	GetDialogItem(theDialog, 5, &itemType, &item, &box);
	short justShortValue = GetControlValue((ControlHandle)item);
	justification = Fix2Frac(FixDiv(ff(justShortValue), ff(kJustShortMax)));
	
	// .. and orientation
	short textOrientation;
	GetDialogItem(theDialog, 6, &itemType, &item, &box);
	if (GetControlValue((ControlHandle)item) == 1) textOrientation = kHorizontalText;
	else textOrientation = kVerticalText;
	
	GetDialogItem(theDialog, 4, &itemType, &item, &box);
	
	GrafPtr savePort;
	GetPort(&savePort);
	SetPort(theDialog);
	TextFont(1); // let's use the default application font
	EraseRect(&box);
	// and draw
	status = atsuTextBox(gDlgUnicodeText, gDlgTextLength, &box, flushness, justification, textOrientation, true);
	TextFont(0); // let's go back to the default system font
	SetPort(savePort);

	return status;
	}

OSErr ShowATSUITextBox()
	{
	OSStatus status = noErr;

	QuickAndDirtySetUnicodeTextFromASCII_C_Chars(kSomeVeryLongUnicodeText, &gDlgUnicodeText, &gDlgTextLength);

	DialogPtr theDialog = GetNewDialog(256, NULL, (DialogPtr)-1L);
	
	// set up everything
	short itemType;
	Handle item;
	Rect box;

	// default is left ...
	GetDialogItem(theDialog, 1, &itemType, &item, &box);
	SetControlValue((ControlHandle)item, 1);
	GetDialogItem(theDialog, 2, &itemType, &item, &box);
	SetControlValue((ControlHandle)item, 0);
	GetDialogItem(theDialog, 3, &itemType, &item, &box);
	SetControlValue((ControlHandle)item, 0);

	// ... no justification (0) ...
	GetDialogItem(theDialog, 5, &itemType, &item, &box);
	SetControlMaximum((ControlHandle)item, kJustShortMax);
	SetControlValue((ControlHandle)item, 0);

	// ... and horizontal
	GetDialogItem(theDialog, 6, &itemType, &item, &box);
	SetControlValue((ControlHandle)item, 1);
	GetDialogItem(theDialog, 7, &itemType, &item, &box);
	SetControlValue((ControlHandle)item, 0);

	UpdateUserItem(theDialog);
	
	// somewhat standard modal dialog loop
	short itemHit;
	ModalFilterUPP myFilterProc = NewModalFilterProc(myFilter);
	do	{
		Boolean somethingChanged = false;
		ModalDialog(myFilterProc, &itemHit);
		switch (itemHit)
			{
			case 1:
			case 2:
			case 3:
				if (itemHit != 1)
					{
					GetDialogItem(theDialog, 1, &itemType, &item, &box);
					if (GetControlValue((ControlHandle)item) == 1)
						{
						somethingChanged = true;
						SetControlValue((ControlHandle)item, 0);
						}
					}
				if (itemHit != 2)
					{
					GetDialogItem(theDialog, 2, &itemType, &item, &box);
					if (GetControlValue((ControlHandle)item) == 1)
						{
						somethingChanged = true;
						SetControlValue((ControlHandle)item, 0);
						}
					}
				if (itemHit != 3)
					{
					GetDialogItem(theDialog, 3, &itemType, &item, &box);
					if (GetControlValue((ControlHandle)item) == 1)
						{
						somethingChanged = true;
						SetControlValue((ControlHandle)item, 0);
						}
					}
				GetDialogItem(theDialog, itemHit, &itemType, &item, &box);
				SetControlValue((ControlHandle)item, 1);
				break;
			case 5:
				somethingChanged = true;
				break;
			case 6:
			case 7:
				if (itemHit != 6)
					{
					GetDialogItem(theDialog, 6, &itemType, &item, &box);
					if (GetControlValue((ControlHandle)item) == 1)
						{
						somethingChanged = true;
						SetControlValue((ControlHandle)item, 0);
						}
					}
				if (itemHit != 7)
					{
					GetDialogItem(theDialog, 7, &itemType, &item, &box);
					if (GetControlValue((ControlHandle)item) == 1)
						{
						somethingChanged = true;
						SetControlValue((ControlHandle)item, 0);
						}
					}
				GetDialogItem(theDialog, itemHit, &itemType, &item, &box);
				SetControlValue((ControlHandle)item, 1);
				break;
			}
		if (somethingChanged) UpdateUserItem(theDialog);
		} while (itemHit != 11);
	DisposeDialog(theDialog);
	DisposePtr((Ptr)gDlgUnicodeText);
	return status;
	}

// somewhat standard filter proc
pascal Boolean myFilter(DialogPtr currentDialog, EventRecord *theEventIn, short *theDialogItem)
	{
	Boolean returnVal = false;
	WindowPtr temp;
	if((theEventIn->what == updateEvt) && (theEventIn->message != (long)currentDialog))
		{
	 	DoUpdateWindow((WindowPtr)theEventIn->message);
	    }
	if((theEventIn->what == updateEvt) && (theEventIn->message == (long)currentDialog))
		{
	 	UpdateUserItem(currentDialog);
	    }
	else if((theEventIn->what == mouseDown) && (FindWindow(theEventIn->where, &temp) == inDrag) && (temp == currentDialog))
		{
		DragWindow(temp, theEventIn->where, &qd.screenBits.bounds);
		}
	else
		{ 
		GetPort(&temp);
		SetPort(currentDialog);
		returnVal= StdFilterProc(currentDialog, theEventIn, theDialogItem);
		SetPort(temp);
		}
	return(returnVal);
	}
