/*------------------------------------------------------------------------------
#
#	Macintosh Developer Technical Support
#
#	Simple Apple Text Services For Unicode Imaging (ATSUI) Sample Application
#
#	TypeServicesForUnicode
#
#	WindowUtilities.cp	-	C++ Source
#
#	Copyright  1998 Apple Computer, Inc.
#	All rights reserved.
#	
#	You may incorporate this sample code into your applications without
#	restriction, though the sample code has been provided "AS IS" and the
#	responsibility for its operation is 100% yours.  However, what you are
#	not permitted to do is to redistribute the source as "DSC Sample Code"
#	after having made changes. If you're going to re-distribute the source,
#	we require that you make it clear in the source that the code was
#	descended from Apple Sample Code, but that you've made changes.
#
#	Versions:	1.0					7/98
#
#	Utilites common to the whole sample application.
#
------------------------------------------------------------------------------*/

#include <string.h>
#include <ATSUnicode.h>

#include "SomeUnicodeStuff.h"
#include "WindowUtilities.h"

WindowDataPtr GetWindowData(WindowPtr theWind)
	{
	WindowDataPtr result = NULL;
	if ((theWind != NULL) && (((WindowPeek)theWind)->windowKind == kApplicationWindowKind))
		result = (WindowDataPtr)GetWRefCon(theWind);
	return result;
	}

WindowDataPtr DefaultWindowDataPtr()
	{
	WindowDataPtr wdataP = (WindowDataPtr)NewPtr(sizeof(WindowData));
	if (wdataP != NULL)
		{
		wdataP->sampleKind = 0;
		wdataP->privateData = NULL;
		wdataP->theUnicodeText = NULL;
		wdataP->uTextLength = -1;
		wdataP->xLocation = ff(10);
		wdataP->yLocation = ff(10);
		wdataP->lineHeight = 0;
		wdataP->numberOfLines = 1;
		wdataP->endOfLines = NULL;
		wdataP->numberOfRuns = -1;
		wdataP->runLengths = NULL;
		wdataP->styles = NULL;
		wdataP->textLayout = NULL;
		}
	return wdataP;
	}

void DisposeWindowDataPtr(WindowDataPtr wdataP)
	{
	if (wdataP->privateData != NULL) DisposePtr((Ptr)wdataP->privateData);
	if (wdataP->theUnicodeText != NULL) DisposePtr((Ptr)wdataP->theUnicodeText);
	if (wdataP->endOfLines != NULL) DisposePtr((Ptr)wdataP->endOfLines);
	if (wdataP->runLengths != NULL) DisposePtr((Ptr)wdataP->runLengths);
	if (wdataP->styles != NULL)
		{
		long i;
		for (i=0; i < wdataP->numberOfRuns; i++)
			ATSUDisposeStyle(wdataP->styles[i]);
		DisposePtr((Ptr)wdataP->styles);
		}
	if (wdataP->textLayout != NULL) ATSUDisposeTextLayout(wdataP->textLayout);
	}

ATSUFontID GetFontIDFromMacFontName(char *fontName)
	{
	ATSUFontID result = kATSUInvalidFontID, found;
	OSStatus status = ATSUFindFontFromName((Ptr)fontName, strlen(fontName), 1, kFontNoPlatform, kFontNoScript, kFontNoLanguage, &found);
	if (status == noErr) result = found;
	return result;
	}

void TryToSetFontTo(ATSUStyle theStyle, char *fontName)
	{
	ATSUFontID theFontID = GetFontIDFromMacFontName(fontName);
	if (theFontID == kATSUInvalidFontID) DebugStr("\p can't find this font");
	else
		{
		ATSUAttributeTag theTag = kATSUFontTag;
		ByteCount theSize = sizeof(ATSUFontID);
		ATSUAttributeValuePtr theValuePtr = &theFontID;
		OSStatus status = ATSUSetAttributes(theStyle, 1, &theTag, &theSize, &theValuePtr);
		if (status != noErr) DebugStr("\p ATSUSetAttributes kATSUFontTag failed");
		}
	}
