/*------------------------------------------------------------------------------
#
#	Macintosh Developer Technical Support
#
#	Simple Apple Text Services For Unicode Imaging (ATSUI) Sample Application
#
#	TypeServicesForUnicode
#
#	WindowUtilities.h	-	Header
#
#	Copyright  1998 Apple Computer, Inc.
#	All rights reserved.
#	
#	You may incorporate this sample code into your applications without
#	restriction, though the sample code has been provided "AS IS" and the
#	responsibility for its operation is 100% yours.  However, what you are
#	not permitted to do is to redistribute the source as "DSC Sample Code"
#	after having made changes. If you're going to re-distribute the source,
#	we require that you make it clear in the source that the code was
#	descended from Apple Sample Code, but that you've made changes.
#
#	Versions:	1.0					7/98
#
#	Utilites common to the whole sample application.
#
------------------------------------------------------------------------------*/

#ifndef __WINDOWUTILITIES__
#define __WINDOWUTILITIES__

#ifndef IntToFixed
#define IntToFixed(a)	   ((Fixed)(a) << 16)
#endif

#ifndef ff
#define ff(a)			   IntToFixed(a)
#endif

typedef struct
	{
	long sampleKind;						// to identify the kind of sample (1..8)
	void *privateData;						// some storage

	UniCharArrayPtr theUnicodeText;			// the Text in Unicode
	UniCharCount uTextLength;				// its length
	ATSUTextMeasurement xLocation;			// where it starts drawing at x
	ATSUTextMeasurement yLocation;			//                        and y
	ATSUTextMeasurement maxAscent;			// maximum ascent for the whole text
	ATSUTextMeasurement maxDescent;			// maximum descent for the whole text
	ATSUTextMeasurement lineHeight;			// its line height (maxAscent + maxDescent)
	ItemCount numberOfLines;				// number of lines to draw
	UniCharArrayOffset*	endOfLines;			// positions of the end of line breaks
	ItemCount numberOfRuns;					// number of style runs
	UniCharCount *runLengths;				// array of the lengths of each style run
	ATSUStyle *styles;						// array of styles
	ATSUTextLayout textLayout;				// the resulting text layout
	} WindowData, *WindowDataPtr;

WindowDataPtr GetWindowData(WindowPtr theWind);
WindowDataPtr DefaultWindowDataPtr();
void DisposeWindowDataPtr(WindowDataPtr wdataP);

ATSUFontID GetFontIDFromMacFontName(char *fontName);
void TryToSetFontTo(ATSUStyle theStyle, char *fontName);

#endif
